/* This program is free software; you can redistribute it and/or modify it */
/* under the terms of the GNU General Public License version 2 as          */
/* published by the Free Software Foundation.                              */
/*                                                                         */
/* This program is distributed in the hope that it will be useful, but     */
/* WITHOUT ANY WARRANTY; without even the implied warranty of              */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        */
/* General Public License for more details.                                */
/*                                                                         */
/* You should have received a copy of the GNU General Public License along */
/* with this program; if not, write to the Free Software Foundation, Inc., */
/* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.                */

/* Si 1, avec ascii anglais  (joli) */
/* Si 0, avec ascii francais (commun) */

#define intdosx(x,y,z) int86x(0x21,x,y,z)
#define intdos(x,y) int86(0x21,x,y)

#if defined(__WATCOMC__)
#define DOSREGPACK union REGPACK
#define r_ds w.ds
#define r_dx w.dx
#define r_ax w.ax
#define r_es w.es
#define r_bx w.bx
#define r_cx w.cx
#define r_cl h.cl
#define r_bl h.bl
#define r_si w.si
#define r_di w.di
#define r_flags w.flags
#elif defined(__PACIFIC__)
#define DOSREGPACK union REGPACK
#define r_ds x.ds
#define r_dx x.dx
#define r_ax x.ax
#define r_es x.es
#define r_bx x.bx
#define r_cx x.cx
#define r_cl h.cl
#define r_bl h.bl
#define r_si x.si
#define r_di x.di
#define r_flags x.flags
#else
#define DOSREGPACK struct REGPACK
#endif

/*Dfinition de la structure de l'awal*/
typedef struct
{
    char nom1[25];
    char nom2[25];
	int case_moi[6];
	int case_cpu[6];
	int score_moi;
	int score_cpu;
	int tour_jeu;  /* Ne sert que dans l'affichage*/
	int difficulte; /* 0 idiot, 9 gnie*/
	int fini;     /*  1 si le jeu est termin*/
} awale;


/* Dfinition de la structure de la case  retourner avec le gain de score*/
typedef struct
{
	int case_meilleure;
	int gain_score;
} case_retour;

/* pour les commentaires des fonctions cf. awale.c*/


int return_valeur(int a,int b); /* Demande une valeur entre a et b et la retourne*/

#ifndef __TURBOC__
void clrscr(void);
#endif
void pause(void);
int getcharacter(int mode);
void put_console(int c);
void viewrules(void);
void initialiser(awale* a,int total); /* si total==1, initialise les noms et dif*/
void afficher(awale a);
void afficher_beau(awale a);
void afficher_commun(awale a);
void joueur_joue(awale* a,int case_choisie);
void cpu_joue(awale* a,int case_choisie);
void demande_joueur(awale* a);
void demande_cpu(awale* a);
void terminer_jeu(awale* a);
case_retour meilleure_case_cpu(awale a,int nbre_recursif);
case_retour meilleure_case_joueur(awale a,int nbre_recursif);
void afficher_gagnant_1joueur(awale a);
void afficher_gagnant_demo(void);
void afficher_gagnant_2joueurs(awale a);
void lance_jeu_1joueur(awale* a);
void lance_jeu_demo(awale* a);
void lance_jeu_2joueurs(awale* a);
void changer_difficulte(awale *a);
void changer_noms(awale* a);
